<template>
  <q-page padding>
    <div class="column">
      <div class="row justify-center full-width">
        <q-form @submit="getStats">
          <q-input v-model="answer" placeholder="Balrog" type="text" hint="You shall not pass"/>
          <div class="row justify-end">
            <q-btn
              no-caps
              type="submit"
              class="q-mt-md"
              color="dark"
              label="Submit"
            />
          </div>
        </q-form>
      </div>

      <div class="row justify-center full-width" v-if="pincodes && requests">
        <div class="col-12 col-md-6">
          <div class="text-h5">Requests</div>
          <div class="text-subtitle1">Total requests: {{ requests.total_requests }}</div>
          <div class="text-subtitle1">Null requests:</div>
          <div class="q-ml-sm text-subtitle2">Total: {{ requests.null_requests.total }}</div>
          <div class="q-ml-sm text-subtitle2">iPhone: {{ requests.null_requests.iphone }}</div>
          <div class="q-ml-sm text-subtitle2">Android: {{ requests.null_requests.android }}</div>
          <div class="q-ml-sm text-subtitle2">MacOS: {{ requests.null_requests.macos }}</div>
          <div class="q-ml-sm text-subtitle2">Windows: {{ requests.null_requests.windows }}</div>
          <div class="q-ml-sm text-subtitle2">Linux: {{ requests.null_requests.linux }}</div>
          <div class="text-subtitle1">Bounce rate: {{ requests.bounce_rate }}</div>
          <div class="text-subtitle1">Number of push received: {{ requests.number_of_push_received }}</div>
          <div class="text-subtitle1">Number of push sent: {{ requests.number_of_push_send }}</div>
          <div class="text-subtitle1">Number of plus 18: {{ requests.number_of_plus18 }}</div>
          <div class="text-subtitle1">Number of plus 45: {{ requests.number_of_plus45 }}</div>
        </div>

        <div class="col-12 col-md-6">
          <div class="text-h5">Pincodes</div>
          <div class="text-subtitle1">Total pincodes: {{ pincodes.total_pincodes }}</div>
          <div class="text-subtitle1">Total batch: {{ pincodes.total_batch }}</div>
          <div class="text-subtitle1">Running batch push: {{ pincodes.running_batch_push }}</div>
        </div>
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
export default defineComponent({
  name: 'AdminPanel',

  data () {
    return {
      pincodes: null,
      requests: null,
      answer: ''
    }
  },

  methods: {
    getStats: function () {
      this.$axios.post('/api/stats/requests', {
        passcode: this.answer
      })
        .then((response) => {
          this.requests = response.data
          return this.$axios.post('/api/stats/pincodes', {
            passcode: this.answer
          })
        }).then((response) => {
          this.pincodes = response.data
        })
        .catch((error) => {
          console.log(error)
        })
    }
  }
})
</script>
